tree grammar driver;

options {
    tokenVocab=pipe;
    output=AST;
    ASTLabelType=CommonTree;
    language=Java;
}

@members {
    STGroupFile g=new STGroupFile("st/go.stg");
    ST main=g.getInstanceOf("main");
}

@header {
import org.stringtemplate.v4.*;
import java.util.HashMap;
import java.io.FileWriter;
import java.util.ArrayList;
}


// (game)+
starting
@init
{
    // STGroupFile g=new STGroupFile("st/go.stg");
    // ST main=g.getInstanceOf("main");
}
@after{
    String result =  main.render();
    System.out.println(result);
    
    try{
        FileWriter fw = new FileWriter("method_chaining_demo/"+"go.cpp");
        fw.write(result);
        fw.flush();
    }
    catch (java.io.IOException e)
        {
            System.err.println(e); 
        }
}
    : (game)+
    ;

//^(CLASS SYMBOL_NAME (node)*)
game
@init
{
    class call{
        public String node_name;
        public String para_val;
        public String getNode_name() {return node_name;}
        public String getPara_val() {return para_val;}
    };
}
 : ^(CLASS SYMBOL_NAME
            {
                String class_name = $SYMBOL_NAME.text;
                main.add("include", class_name);
                String instance_of_class="o_"+class_name;
                main.addAggr("create.{class_name, instance_name}", class_name, instance_of_class);
                main.add("destroy", instance_of_class);
                List<call> method_chain = new ArrayList<call>();
            }
            (node
                {
                    call calling = new call();
                    calling.node_name=$node.node_name;
                    calling.para_val=$node.para_val;
                    method_chain.add(calling);
                }
            )*
            {
               main.addAggr("call.{class_name, method_chain}", instance_of_class, method_chain);
            }
        )
    ;

//^(NODE SYMBOL_NAME (PARA INT)?)
node
returns [String node_name, String para_val]
@init
{
    $node_name="";
    $para_val="";
}
    : 
        ^(NODE SYMBOL_NAME (PARA INT
                {
                    $para_val = $INT.text;
                }
            )?)
        {
            $node_name=$SYMBOL_NAME.text;
        }
    ;
